ros-jazzy-joint-trajectory-controller (4.15.0-1noble) noble; urgency=high



 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Sun, 06 Oct 2024 23:00:00 -0000

ros-jazzy-joint-trajectory-controller (4.14.0-1noble) noble; urgency=high

  * rename get/set_state to get/set_lifecylce_state (#1250 <https://github.com/ros-controls/ros2_controllers/issues/1250>)
  * Contributors: Manuel Muth

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Tue, 10 Sep 2024 23:00:00 -0000

ros-jazzy-joint-trajectory-controller (4.13.0-1noble) noble; urgency=high



 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Wed, 21 Aug 2024 23:00:00 -0000

ros-jazzy-joint-trajectory-controller (4.12.1-1noble) noble; urgency=high



 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Tue, 13 Aug 2024 23:00:00 -0000

ros-jazzy-joint-trajectory-controller (4.12.0-1noble) noble; urgency=high

  * [JTC] Refactor URDF Model parsing  (#1227 <https://github.com/ros-controls/ros2_controllers/issues/1227>)
  * Use the internal methods instead of using the variables directly (#1221 <https://github.com/ros-controls/ros2_controllers/issues/1221>)
  * Unused header cleanup (#1199 <https://github.com/ros-controls/ros2_controllers/issues/1199>)
  * Fix WaitSet issue in tests  (#1206 <https://github.com/ros-controls/ros2_controllers/issues/1206>)
  * [JTC] Fix test_tolerances_via_actions (#1209 <https://github.com/ros-controls/ros2_controllers/issues/1209>)
  * Fix parallel gripper controller CI (#1202 <https://github.com/ros-controls/ros2_controllers/issues/1202>)
  * Contributors: Christoph Fröhlich, Henry Moore, Sai Kishor Kothakota

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Mon, 22 Jul 2024 23:00:00 -0000

ros-jazzy-joint-trajectory-controller (4.11.0-1noble) noble; urgency=high

  * [JTC] Make goal_time_tolerance overwrite default value only if explicitly set (#1192 <https://github.com/ros-controls/ros2_controllers/issues/1192>)
  * added changes corresponding to the logger and clock propagation in ResourceManager (#1184 <https://github.com/ros-controls/ros2_controllers/issues/1184>)
  * [JTC] Process tolerances sent with action goal (#716 <https://github.com/ros-controls/ros2_controllers/issues/716>)
  * Contributors: Christoph Fröhlich, Felix Exner (fexner), Sai Kishor Kothakota

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Mon, 08 Jul 2024 23:00:00 -0000

ros-jazzy-joint-trajectory-controller (4.10.0-1noble) noble; urgency=high

  * Remove manual angle-wraparound parameter (#1152 <https://github.com/ros-controls/ros2_controllers/issues/1152>)
  * Contributors: Christoph Fröhlich

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Sun, 30 Jun 2024 23:00:00 -0000

ros-jazzy-joint-trajectory-controller (4.9.0-1noble) noble; urgency=high

  * JTC trajectory end time validation fix (#1090 <https://github.com/ros-controls/ros2_controllers/issues/1090>)
  * Contributors: Henry Moore

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Tue, 04 Jun 2024 23:00:00 -0000

ros-jazzy-joint-trajectory-controller (4.8.0-1noble) noble; urgency=high

  * [JTC] Remove unused test code (#1095 <https://github.com/ros-controls/ros2_controllers/issues/1095>)
  * Contributors: Bence Magyar

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Mon, 13 May 2024 23:00:00 -0000

ros-jazzy-joint-trajectory-controller (4.7.0-1noble) noble; urgency=high

  * Remove action_msg dependency (#1077 <https://github.com/ros-controls/ros2_controllers/issues/1077>)
  * Bump version of pre-commit hooks (#1073 <https://github.com/ros-controls/ros2_controllers/issues/1073>)
  * Added conditioning to have rolling tags compilable in older versions (#1071 <https://github.com/ros-controls/ros2_controllers/issues/1071>)
  * Parse URDF for continuous joints (#949 <https://github.com/ros-controls/ros2_controllers/issues/949>)
  * Contributors: Christoph Fröhlich, Sai Kishor Kothakota, github-actions[bot]

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Fri, 22 Mar 2024 00:00:00 -0000

ros-jazzy-joint-trajectory-controller (4.6.0-1noble) noble; urgency=high

  * Fix usage of M_PI on Windows (#1036 <https://github.com/ros-controls/ros2_controllers/issues/1036>)
  * [JTC] Angle wraparound for first segment of trajectory (#796 <https://github.com/ros-controls/ros2_controllers/issues/796>)
  * Add test_depend on hardware_interface_testing (#1018 <https://github.com/ros-controls/ros2_controllers/issues/1018>)
  * Fix tests for using new get_node_options API (#840 <https://github.com/ros-controls/ros2_controllers/issues/840>)
  * Contributors: Christoph Fröhlich, Sai Kishor Kothakota, Silvio Traversaro

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Mon, 12 Feb 2024 00:00:00 -0000

ros-jazzy-joint-trajectory-controller (4.5.0-1noble) noble; urgency=high

  * [JTC] Fill action error_strings (#887 <https://github.com/ros-controls/ros2_controllers/issues/887>)
  * Add tests for interface_configuration_type consistently (#899 <https://github.com/ros-controls/ros2_controllers/issues/899>)
  * Let sphinx add parameter description with nested structures to documentation (#652 <https://github.com/ros-controls/ros2_controllers/issues/652>)
  * [JTC] Invalidate empty trajectory messages (#902 <https://github.com/ros-controls/ros2_controllers/issues/902>)
  * Revert "[JTC] Remove read_only from 'joints', 'state_interfaces' and 'command_interfaces' parameters (#967 <https://github.com/ros-controls/ros2_controllers/issues/967>)" (#978 <https://github.com/ros-controls/ros2_controllers/issues/978>)
  * [JTC] Convert lambda to class functions (#945 <https://github.com/ros-controls/ros2_controllers/issues/945>)
  * Contributors: Christoph Fröhlich, Noel Jiménez García

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Wed, 31 Jan 2024 00:00:00 -0000

ros-jazzy-joint-trajectory-controller (4.4.0-1noble) noble; urgency=high

  * Cancel goal in on_deactivate (#962 <https://github.com/ros-controls/ros2_controllers/issues/962>)
  * Remove read_only from 'joints', 'state_interfaces' and 'command_interfaces' parameters (#967 <https://github.com/ros-controls/ros2_controllers/issues/967>)
  * Contributors: Christoph Fröhlich, Noel Jiménez García

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Thu, 11 Jan 2024 00:00:00 -0000

ros-jazzy-joint-trajectory-controller (4.3.0-1noble) noble; urgency=high

  * Update deprecated topic name (#964 <https://github.com/ros-controls/ros2_controllers/issues/964>)
  * Add few warning flags to error (#961 <https://github.com/ros-controls/ros2_controllers/issues/961>)
  * [JTC] Cleanup includes (#943 <https://github.com/ros-controls/ros2_controllers/issues/943>)
  * Add rqt_JTC to docs (#950 <https://github.com/ros-controls/ros2_controllers/issues/950>)
  * [JTC] Add console output for tolerance checks (#932 <https://github.com/ros-controls/ros2_controllers/issues/932>)
  * Contributors: Christoph Fröhlich, Sai Kishor Kothakota, maurice

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Mon, 08 Jan 2024 00:00:00 -0000

ros-jazzy-joint-trajectory-controller (4.2.0-1noble) noble; urgency=high

  * Cleanup package.xml und clarify tests of JTC. (#889 <https://github.com/ros-controls/ros2_controllers/issues/889>)
  * Fix floating point comparison in JTC (#879 <https://github.com/ros-controls/ros2_controllers/issues/879>)
  * Contributors: Abishalini Sivaraman, Dr. Denis

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Tue, 12 Dec 2023 00:00:00 -0000

ros-jazzy-joint-trajectory-controller (4.1.0-1noble) noble; urgency=high

  * [JTC] Continue with last trajectory-point on success (#842 <https://github.com/ros-controls/ros2_controllers/issues/842>)
  * [JTC] Remove start_with_holding option (#839 <https://github.com/ros-controls/ros2_controllers/issues/839>)
  * [JTC] Activate checks for parameter validation (#857 <https://github.com/ros-controls/ros2_controllers/issues/857>)
  * [JTC] Improve update methods for tests (#858 <https://github.com/ros-controls/ros2_controllers/issues/858>)
  * Contributors: Christoph Fröhlich

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Fri, 01 Dec 2023 00:00:00 -0000

ros-jazzy-joint-trajectory-controller (4.0.0-1noble) noble; urgency=high

  * fix tests for API break of passing controller manager update rate in init method (#854 <https://github.com/ros-controls/ros2_controllers/issues/854>)
  * [JTC] Fix dynamic reconfigure of tolerances (#849 <https://github.com/ros-controls/ros2_controllers/issues/849>)
  * [JTC] Remove unused home pose (#845 <https://github.com/ros-controls/ros2_controllers/issues/845>)
  * [JTC] Activate update of dynamic parameters (#761 <https://github.com/ros-controls/ros2_controllers/issues/761>)
  * [JTC] Fix tests when state offset is used (#797 <https://github.com/ros-controls/ros2_controllers/issues/797>)
  * [JTC] Remove deprecation warnings, set allow_nonzero_velocity_at_trajectory_end default false (#834 <https://github.com/ros-controls/ros2_controllers/issues/834>)
  * Adjust tests after passing URDF to controllers (#817 <https://github.com/ros-controls/ros2_controllers/issues/817>)
  * Contributors: Bence Magyar, Christoph Fröhlich, Sai Kishor Kothakota, Dr Denis

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Tue, 21 Nov 2023 00:00:00 -0000

ros-jazzy-joint-trajectory-controller (3.17.0-1noble) noble; urgency=high

  * Cleanup comments and unnecessary checks (#803 <https://github.com/ros-controls/ros2_controllers/issues/803>)
  * Update requirements of state interfaces (#798 <https://github.com/ros-controls/ros2_controllers/issues/798>)
  * [JTC] Add tests for acceleration command interface (#752 <https://github.com/ros-controls/ros2_controllers/issues/752>)
  * Contributors: Christoph Fröhlich

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Tue, 31 Oct 2023 00:00:00 -0000

ros-jazzy-joint-trajectory-controller (3.16.0-1noble) noble; urgency=high

  * [Docs] Improve interface description of JTC (#770 <https://github.com/ros-controls/ros2_controllers/issues/770>)
  * [JTC] Add time-out for trajectory interfaces (#609 <https://github.com/ros-controls/ros2_controllers/issues/609>)
  * [JTC] Rename parameter: normalize_error to angle_wraparound (#772 <https://github.com/ros-controls/ros2_controllers/issues/772>)
  * [JTC] Fix hold position mode with goal_time>0 (#758 <https://github.com/ros-controls/ros2_controllers/issues/758>)
  * [JTC] Add note on goal_time=0 in docs (#773 <https://github.com/ros-controls/ros2_controllers/issues/773>)
  * Contributors: Christoph Fröhlich

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Tue, 19 Sep 2023 23:00:00 -0000

ros-jazzy-joint-trajectory-controller (3.15.0-1noble) noble; urgency=high

  * [JTC] Make most parameters read-only (#771 <https://github.com/ros-controls/ros2_controllers/issues/771>)
  * Contributors: Christoph Fröhlich

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Sun, 10 Sep 2023 23:00:00 -0000

ros-jazzy-joint-trajectory-controller (3.14.0-1noble) noble; urgency=high

  * [JTC] Tolerance tests + Hold on time violation (#613 <https://github.com/ros-controls/ros2_controllers/issues/613>)
    * Add new test to ensure that controller goes into position holding when tolerances are violated
    * Hold position if goal_time is exceeded with topic interface
    * Fix hold on time-violation
  * [JTC] Fix typos, implicit cast, const member functions (#748 <https://github.com/ros-controls/ros2_controllers/issues/748>)
  * Remove wrong description (#742 <https://github.com/ros-controls/ros2_controllers/issues/742>)
  * [JTC] Explicitly set hold position (#558 <https://github.com/ros-controls/ros2_controllers/issues/558>)
  * Contributors: Christoph Fröhlich

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Tue, 15 Aug 2023 23:00:00 -0000

ros-jazzy-joint-trajectory-controller (3.13.0-1noble) noble; urgency=high

  * Small improvement in remapping (#393 <https://github.com/ros-controls/ros2_controllers/issues/393>)
  * [JTC] Update trajectory documentation (#714 <https://github.com/ros-controls/ros2_controllers/issues/714>)
  * [JTC] Reject messages with effort fields (#699 <https://github.com/ros-controls/ros2_controllers/issues/699>) (#719 <https://github.com/ros-controls/ros2_controllers/issues/719>)
  * [Doc] Fix links (#715 <https://github.com/ros-controls/ros2_controllers/issues/715>)
  * Contributors: Andy Zelenak, Bence Magyar, Christoph Fröhlich

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Thu, 03 Aug 2023 23:00:00 -0000

ros-jazzy-joint-trajectory-controller (3.12.0-1noble) noble; urgency=high

  * Remove reactivation test from ROS 1
  * Don't test update after cleanup
  * Fix namespace for parameter traits(#703 <https://github.com/ros-controls/ros2_controllers/issues/703>)
  * Fixed update period computation in test (#693 <https://github.com/ros-controls/ros2_controllers/issues/693>)
  * [JTC] Reject trajectories with nonzero terminal velocity (#567 <https://github.com/ros-controls/ros2_controllers/issues/567>)
  * Compute velocity errors when using an effort command interface (#679 <https://github.com/ros-controls/ros2_controllers/issues/679>)
  * Add test for velocity error with effort cmd interface (#690 <https://github.com/ros-controls/ros2_controllers/issues/690>)
  * Revert "[JTC] Command final waypoint identically when traj_point_active_ptr_ is nullptr (#682 <https://github.com/ros-controls/ros2_controllers/issues/682>)"
  * [JTC] Fix time sources and wrong checks in tests (#686 <https://github.com/ros-controls/ros2_controllers/issues/686>)
  * Increase action tests timeout (#680 <https://github.com/ros-controls/ros2_controllers/issues/680>)
  * [JTC] Extend tests (#612 <https://github.com/ros-controls/ros2_controllers/issues/612>)
  * [JTC] Command final waypoint identically when traj_point_active_ptr_ is nullptr (#682 <https://github.com/ros-controls/ros2_controllers/issues/682>)
  * Contributors: Christoph Fröhlich, Ethan Gordon, Lars Tingelstad, gwalck, Bence Magyar

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Mon, 17 Jul 2023 23:00:00 -0000

ros-jazzy-joint-trajectory-controller (3.11.0-1noble) noble; urgency=high

  * jtc: fix minor typo in traj validation error msg (#674 <https://github.com/ros-controls/ros2_controllers/issues/674>)
  * Added -Wconversion flag and fix warnings (#667 <https://github.com/ros-controls/ros2_controllers/issues/667>)
  * Contributors: G.A. vd. Hoorn, gwalck

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Fri, 23 Jun 2023 23:00:00 -0000

ros-jazzy-joint-trajectory-controller (3.10.1-1noble) noble; urgency=high



 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Mon, 05 Jun 2023 23:00:00 -0000

ros-jazzy-joint-trajectory-controller (3.10.0-1noble) noble; urgency=high

  * enable ReflowComments to also use ColumnLimit on comments (#625 <https://github.com/ros-controls/ros2_controllers/issues/625>)
  * Contributors: Sai Kishor Kothakota

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Sat, 03 Jun 2023 23:00:00 -0000

ros-jazzy-joint-trajectory-controller (3.9.0-1noble) noble; urgency=high

  * Use branch name substitution for all links (#618 <https://github.com/ros-controls/ros2_controllers/issues/618>)
  * [JTC] Fix deprecated header (#610 <https://github.com/ros-controls/ros2_controllers/issues/610>)
  * Fix github links on control.ros.org (#604 <https://github.com/ros-controls/ros2_controllers/issues/604>)
  * Contributors: Christoph Fröhlich

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Sat, 27 May 2023 23:00:00 -0000

ros-jazzy-joint-trajectory-controller (3.8.0-1noble) noble; urgency=high

  * [JTC] Import docs from wiki.ros.org (#566 <https://github.com/ros-controls/ros2_controllers/issues/566>)
  * Contributors: Christoph Fröhlich

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Sat, 13 May 2023 23:00:00 -0000

ros-jazzy-joint-trajectory-controller (3.7.0-1noble) noble; urgency=high

  * Fix JTC from immediately returning success (#565 <https://github.com/ros-controls/ros2_controllers/issues/565>)
  * Contributors: Marq Rasmussen

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Mon, 01 May 2023 23:00:00 -0000

ros-jazzy-joint-trajectory-controller (3.6.0-1noble) noble; urgency=high

  * Renovate load controller tests (#569 <https://github.com/ros-controls/ros2_controllers/issues/569>)
  * Fix docs format (#589 <https://github.com/ros-controls/ros2_controllers/issues/589>)
  * [JTC] Implement new ~/controller_state message (#557 <https://github.com/ros-controls/ros2_controllers/issues/557>)
  * Contributors: Bence Magyar, Christoph Fröhlich

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Fri, 28 Apr 2023 23:00:00 -0000

ros-jazzy-joint-trajectory-controller (3.5.0-1noble) noble; urgency=high

  * [Parameters] Use gt_eq instead of deprecated lower_bounds in validators (#561 <https://github.com/ros-controls/ros2_controllers/issues/561>)
  * [JTC] Disable use of closed-loop PID adapter if controller is used in open-loop mode. (#551 <https://github.com/ros-controls/ros2_controllers/issues/551>)
  * Contributors: Dr. Denis

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Thu, 13 Apr 2023 23:00:00 -0000

ros-jazzy-joint-trajectory-controller (3.4.0-1noble) noble; urgency=high

  * Update JTC documentation (#541 <https://github.com/ros-controls/ros2_controllers/issues/541>)
  * Contributors: Christoph Fröhlich

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Sat, 01 Apr 2023 23:00:00 -0000

ros-jazzy-joint-trajectory-controller (3.3.0-1noble) noble; urgency=high

  * Add comments about auto-generated header files (#539 <https://github.com/ros-controls/ros2_controllers/issues/539>)
  * 🕰️ remove state publish rate from JTC. (#520 <https://github.com/ros-controls/ros2_controllers/issues/520>)
  * Contributors: AndyZe, Dr. Denis

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Tue, 07 Mar 2023 00:00:00 -0000

ros-jazzy-joint-trajectory-controller (3.2.0-1noble) noble; urgency=high

  * fix JTC segfault (#518 <https://github.com/ros-controls/ros2_controllers/issues/518>)
  * fix interpolation logic (#516 <https://github.com/ros-controls/ros2_controllers/issues/516>)
  * Fix overriding of install (#510 <https://github.com/ros-controls/ros2_controllers/issues/510>)
  * Add JTC normalize_error parameter to doc (#511 <https://github.com/ros-controls/ros2_controllers/issues/511>)
  * Fix JTC segfault on unload (#515 <https://github.com/ros-controls/ros2_controllers/issues/515>)
  * Don't set interpolation_method_ twice (#517 <https://github.com/ros-controls/ros2_controllers/issues/517>)
  * Remove compile warnings. (#519 <https://github.com/ros-controls/ros2_controllers/issues/519>)
  * Contributors: Andy Zelenak, Christoph Fröhlich, Dr. Denis, Michael Wiznitzer, Márk Szitanics, Solomon Wiznitzer, Tyler Weaver, Chris Thrasher

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Fri, 10 Feb 2023 00:00:00 -0000

ros-jazzy-joint-trajectory-controller (3.1.0-1noble) noble; urgency=high

  * ported the joint_trajectory_controller query_state service to ROS2 (#481 <https://github.com/ros-controls/ros2_controllers/issues/481>)
  * [JTC] Configurable joint positon error normalization behavior (#491 <https://github.com/ros-controls/ros2_controllers/issues/491>)
  * Contributors: Christoph Fröhlich, Sai Kishor Kothakota, Bence Magyar

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Thu, 26 Jan 2023 00:00:00 -0000

ros-jazzy-joint-trajectory-controller (3.0.0-1noble) noble; urgency=high

  * [JTC] Add pid gain structure to documentation (#485 <https://github.com/ros-controls/ros2_controllers/issues/485>)
  * [JTC] Activate test for only velocity controller (#487 <https://github.com/ros-controls/ros2_controllers/issues/487>)
  * [JTC] Allow ff_velocity_scale=0 without deprecated warning (#490 <https://github.com/ros-controls/ros2_controllers/issues/490>)
  * Add backward_ros to all controllers (#489 <https://github.com/ros-controls/ros2_controllers/issues/489>)
  * Fix markup in userdoc.rst (#480 <https://github.com/ros-controls/ros2_controllers/issues/480>)
  * [JTC] Remove deprecation from parameters validation file. (#476 <https://github.com/ros-controls/ros2_controllers/issues/476>)
  * Contributors: Bence Magyar, Christoph Fröhlich, Denis Štogl

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Thu, 19 Jan 2023 00:00:00 -0000

ros-jazzy-joint-trajectory-controller (2.15.0-1noble) noble; urgency=high



 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Tue, 06 Dec 2022 00:00:00 -0000

ros-jazzy-joint-trajectory-controller (2.14.0-1noble) noble; urgency=high

  * Fix parameter library export (#448 <https://github.com/ros-controls/ros2_controllers/issues/448>)
  * Contributors: Tyler Weaver

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Fri, 18 Nov 2022 00:00:00 -0000

ros-jazzy-joint-trajectory-controller (2.13.0-1noble) noble; urgency=high

  * Generate Parameter Library for Joint Trajectory Controller (#384 <https://github.com/ros-controls/ros2_controllers/issues/384>)
  * Fix rates in JTC userdoc.rst (#433 <https://github.com/ros-controls/ros2_controllers/issues/433>)
  * Fix for high CPU usage by JTC in gzserver (#428 <https://github.com/ros-controls/ros2_controllers/issues/428>)
    * Change type cast wall timer period from second to nanoseconds.
    create_wall_timer() expects delay in nanoseconds (duration object) however the type cast to seconds will result in 0 (if duration is less than 1s) and thus causing timer to be fired non stop resulting in very high CPU usage.
    * Reset smartpointer so that create_wall_timer() call can destroy previous trajectory timer.
    node->create_wall_timer() first removes timers associated with expired smartpointers before servicing current request.  The JTC timer pointer gets overwrite only after the create_wall_timer() returns and thus not able to remove previous trajectory timer resulting in upto two timers running for JTC during trajectory execution.  Althougth the previous timer does nothing but still get fired.
  * Contributors: Arshad Mehmood, Borong Yuan, Tyler Weaver, Andy Zelenak, Bence Magyar, Denis Štogl

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Tue, 04 Oct 2022 23:00:00 -0000

ros-jazzy-joint-trajectory-controller (2.12.0-1noble) noble; urgency=high

  * Use a "steady clock" when measuring time differences (#427 <https://github.com/ros-controls/ros2_controllers/issues/427>)
  * [JTC] Add additional parameter to enable configuration of interfaces for following controllers in a chain. (#380 <https://github.com/ros-controls/ros2_controllers/issues/380>)
  * test: :white_check_mark: fix and add back joint_trajectory_controller state_topic_consistency (#415 <https://github.com/ros-controls/ros2_controllers/issues/415>)
  * Reinstate JTC tests (#391 <https://github.com/ros-controls/ros2_controllers/issues/391>)
  * [JTC] Hold position if tolerance is violated even during non-active goal (#368 <https://github.com/ros-controls/ros2_controllers/issues/368>)
  * Small fixes for JTC. (#390 <https://github.com/ros-controls/ros2_controllers/issues/390>)
    variables in JTC to not clutter other PR with them.
    fixes of updating parameters on renewed configuration of JTC that were missed
  * Contributors: Andy Zelenak, Bence Magyar, Denis Štogl, Jaron Lundwall, Michael Wiznitzer

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Wed, 31 Aug 2022 23:00:00 -0000

ros-jazzy-joint-trajectory-controller (2.11.0-1noble) noble; urgency=high



 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Wed, 03 Aug 2022 23:00:00 -0000

ros-jazzy-joint-trajectory-controller (2.10.0-1noble) noble; urgency=high

  * Make JTC callbacks methods with clear names (#397 <https://github.com/ros-controls/ros2_controllers/issues/397>) #abi-breaking
  * Use system time in all tests to avoid error with different time sources. (#334 <https://github.com/ros-controls/ros2_controllers/issues/334>)
  * Contributors: Bence Magyar, Denis Štogl

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Sun, 31 Jul 2022 23:00:00 -0000

ros-jazzy-joint-trajectory-controller (2.9.0-1noble) noble; urgency=high

  * Add option to skip interpolation in the joint trajectory controller (#374 <https://github.com/ros-controls/ros2_controllers/issues/374>)
    * Introduce InterpolationMethods structure
    * Use parameters to define interpolation use in JTC
  * Contributors: Andy Zelenak

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Wed, 13 Jul 2022 23:00:00 -0000

ros-jazzy-joint-trajectory-controller (2.8.0-1noble) noble; urgency=high

  * Preallocate JTC variables to avoid resizing in realtime loops (#340 <https://github.com/ros-controls/ros2_controllers/issues/340>)
  * Contributors: Andy Zelenak

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Fri, 08 Jul 2022 23:00:00 -0000

ros-jazzy-joint-trajectory-controller (2.7.0-1noble) noble; urgency=high

  * Properly retrieve parameters in the Joint Trajectory Controller (#365 <https://github.com/ros-controls/ros2_controllers/issues/365>)
  * Rename the "abort" variable in the joint traj controller (#367 <https://github.com/ros-controls/ros2_controllers/issues/367>)
  * account for edge case in JTC (#350 <https://github.com/ros-controls/ros2_controllers/issues/350>)
  * Contributors: Andy Zelenak, Michael Wiznitzer

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Sat, 02 Jul 2022 23:00:00 -0000

ros-jazzy-joint-trajectory-controller (2.6.0-1noble) noble; urgency=high

  * Disable failing workflows (#363 <https://github.com/ros-controls/ros2_controllers/issues/363>)
  * Fixed lof message in joint_trayectory_controller (#366 <https://github.com/ros-controls/ros2_controllers/issues/366>)
  * CMakeLists cleanup (#362 <https://github.com/ros-controls/ros2_controllers/issues/362>)
  * Fix exception about parameter already been declared & Change default c++ version to 17 (#360 <https://github.com/ros-controls/ros2_controllers/issues/360>)
    * Default C++ version to 17
    * Replace explicit use of declare_paremeter with auto_declare
  * Member variable renaming in the Joint Traj Controller (#361 <https://github.com/ros-controls/ros2_controllers/issues/361>)
  * Contributors: Alejandro Hernández Cordero, Andy Zelenak, Jafar Abdi

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Fri, 17 Jun 2022 23:00:00 -0000

ros-jazzy-joint-trajectory-controller (2.5.0-1noble) noble; urgency=high

  * check for nans in command interface (#346 <https://github.com/ros-controls/ros2_controllers/issues/346>)
  * Contributors: Michael Wiznitzer

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Thu, 12 May 2022 23:00:00 -0000

ros-jazzy-joint-trajectory-controller (2.4.0-1noble) noble; urgency=high

  * Fix a gtest deprecation warning (#341 <https://github.com/ros-controls/ros2_controllers/issues/341>)
  * Delete unused variable in joint_traj_controller (#339 <https://github.com/ros-controls/ros2_controllers/issues/339>)
  * updated to use node getter functions (#329 <https://github.com/ros-controls/ros2_controllers/issues/329>)
  * Fix JTC state tolerance and goal_time tolerance check bug (#316 <https://github.com/ros-controls/ros2_controllers/issues/316>)
    * fix state tolerance check bug
    * hold position when canceling or aborting. update state tolerance test
    * add goal tolerance fail test
    * better state tolerance test
    * use predefined constants
    * fix goal_time logic and tests
    * add comments
  * Contributors: Andy Zelenak, Jack Center, Michael Wiznitzer, Bence Magyar, Denis Štogl

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Thu, 28 Apr 2022 23:00:00 -0000

ros-jazzy-joint-trajectory-controller (2.3.0-1noble) noble; urgency=high

  * [JTC] Allow integration of states in goal trajectories (#190 <https://github.com/ros-controls/ros2_controllers/issues/190>)
    * Added position and velocity deduction to trajectory.
    * Added support for deduction of states from their derivatives.
  * Use CallbackReturn from controller_interface namespace (#333 <https://github.com/ros-controls/ros2_controllers/issues/333>)
  * [JTC] Implement effort-only command interface (#225 <https://github.com/ros-controls/ros2_controllers/issues/225>)
    * Fix trajectory tolerance parameters
    * Implement effort command interface for JTC
    * Use auto_declare for pid params
    * Set effort to 0 on deactivate
  * [JTC] Variable renaming for clearer API (#323 <https://github.com/ros-controls/ros2_controllers/issues/323>)
  * Remove unused include to fix JTC test (#319 <https://github.com/ros-controls/ros2_controllers/issues/319>)
  * Contributors: Akash, Andy Zelenak, Bence Magyar, Denis Štogl, Jafar Abdi, Victor Lopez

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Wed, 20 Apr 2022 23:00:00 -0000

ros-jazzy-joint-trajectory-controller (2.2.0-1noble) noble; urgency=high

  * Use lifecycle node as base for controllers (#244 <https://github.com/ros-controls/ros2_controllers/issues/244>)
  * JointTrajectoryController: added missing control_toolbox dependencies (#315 <https://github.com/ros-controls/ros2_controllers/issues/315>)
  * Use time argument on update function instead of node time (#296 <https://github.com/ros-controls/ros2_controllers/issues/296>)
  * Export dependency (#310 <https://github.com/ros-controls/ros2_controllers/issues/310>)
  * Contributors: DasRoteSkelett, Erick G. Islas-Osuna, Jafar Abdi, Denis Štogl, Vatan Aksoy Tezer, Bence Magyar

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Fri, 25 Mar 2022 00:00:00 -0000

ros-jazzy-joint-trajectory-controller (2.1.0-1noble) noble; urgency=high

  * INSTANTIATE_TEST_CASE_P -> INSTANTIATE_TEST_SUITE_P (#293 <https://github.com/ros-controls/ros2_controllers/issues/293>)
  * Contributors: Bence Magyar

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Wed, 23 Feb 2022 00:00:00 -0000

ros-jazzy-joint-trajectory-controller (2.0.1-1noble) noble; urgency=high

  * Fix missing control_toolbox dependency (#291 <https://github.com/ros-controls/ros2_controllers/issues/291>)
  * Contributors: Denis Štogl

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Tue, 01 Feb 2022 00:00:00 -0000

ros-jazzy-joint-trajectory-controller (2.0.0-1noble) noble; urgency=high

  * [JointTrajectoryController] Add velocity-only command option for JTC with closed loop controller (#239 <https://github.com/ros-controls/ros2_controllers/issues/239>)
    * Add velocity pid support.
    * Remove incorrect init test for only velocity command interface.
    * Add clarification comments for pid aux variables. Adapt update loop.
    * Change dt for pid to appropriate measure.
    * Improve partial commands for velocity-only mode.
    * Extend tests to use velocity-only mode.
    * Increase timeout for velocity-only mode parametrized tests.
    * add is_same_sign for better refactor
    * refactor boolean logic
    * set velocity to 0.0 on deactivate
  * Contributors: Lovro Ivanov, Bence Magyar

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Fri, 28 Jan 2022 00:00:00 -0000

ros-jazzy-joint-trajectory-controller (1.3.0-1noble) noble; urgency=high



 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Tue, 11 Jan 2022 00:00:00 -0000

ros-jazzy-joint-trajectory-controller (1.2.0-1noble) noble; urgency=high



 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Wed, 29 Dec 2021 00:00:00 -0000

ros-jazzy-joint-trajectory-controller (1.1.0-1noble) noble; urgency=high

  * Move interface sorting into ControllerInterface (#259 <https://github.com/ros-controls/ros2_controllers/issues/259>)
  * Revise for-loop style (#254 <https://github.com/ros-controls/ros2_controllers/issues/254>)
  * Contributors: bailaC

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Sun, 24 Oct 2021 23:00:00 -0000

ros-jazzy-joint-trajectory-controller (1.0.0-1noble) noble; urgency=high

  * Remove compile warnings. (#245 <https://github.com/ros-controls/ros2_controllers/issues/245>)
  * Add time and period to update function (#241 <https://github.com/ros-controls/ros2_controllers/issues/241>)
  * Quickfix 🛠: Correct confusing variable name (#240 <https://github.com/ros-controls/ros2_controllers/issues/240>)
  * Unify style of controllers. (#236 <https://github.com/ros-controls/ros2_controllers/issues/236>)
  * Change test to work with Foxy and posterior action API (#237 <https://github.com/ros-controls/ros2_controllers/issues/237>)
  * ros2_controllers code changes to support ros2_controls issue #489 <https://github.com/ros-controls/ros2_controllers/issues/489> (#233 <https://github.com/ros-controls/ros2_controllers/issues/233>)
  * Removing Boost from controllers. (#235 <https://github.com/ros-controls/ros2_controllers/issues/235>)
  * refactor get_current_state to get_state (#232 <https://github.com/ros-controls/ros2_controllers/issues/232>)
  * Contributors: Bence Magyar, Denis Štogl, Márk Szitanics, Tyler Weaver, bailaC

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Tue, 28 Sep 2021 23:00:00 -0000

ros-jazzy-joint-trajectory-controller (0.5.0-1noble) noble; urgency=high

  * Add auto declaration of parameters. (#224 <https://github.com/ros-controls/ros2_controllers/issues/224>)
  * Bring precommit config up to speed with ros2_control (#227 <https://github.com/ros-controls/ros2_controllers/issues/227>)
  * Add initial pre-commit setup. (#220 <https://github.com/ros-controls/ros2_controllers/issues/220>)
  * Enable JTC for hardware having offset from state measurements (#189 <https://github.com/ros-controls/ros2_controllers/issues/189>)
    * Avoid "jumps" with states that have tracking error. All test are passing but separatelly. Is there some kind of timeout?
    * Remove allow_integration_flag
    * Add reading from command interfaces when restarting controller
  * Reduce docs warnings and correct adding guidelines (#219 <https://github.com/ros-controls/ros2_controllers/issues/219>)
  * Contributors: Bence Magyar, Denis Štogl, Lovro Ivanov

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Sun, 29 Aug 2021 23:00:00 -0000

ros-jazzy-joint-trajectory-controller (0.4.1-1noble) noble; urgency=high



 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Wed, 07 Jul 2021 23:00:00 -0000

ros-jazzy-joint-trajectory-controller (0.4.0-1noble) noble; urgency=high

  * Force torque sensor broadcaster (#152 <https://github.com/ros-controls/ros2_controllers/issues/152>)
    * Stabilize joint_trajectory_controller tests
    * Add  rclcpp::shutdown(); to all standalone test functions
  * Fixes for Windows (#205 <https://github.com/ros-controls/ros2_controllers/issues/205>)
    * Export protected joint trajectory controller functions
  * Fix deprecation warnings on Rolling, remove rcutils dependency (#204 <https://github.com/ros-controls/ros2_controllers/issues/204>)
  * Fix parameter initialisation for galactic (#199 <https://github.com/ros-controls/ros2_controllers/issues/199>)
    * Fix parameter initialisation for galactic
    * Fix forward_command_controller the same way
    * Fix other compiler warnings
    * Missing space
  * Fix rolling build (#200 <https://github.com/ros-controls/ros2_controllers/issues/200>)
    * Fix rolling build
    * Stick to printf style
    * Add back :: around interface type
    Co-authored-by: Bence Magyar <mailto:bence.magyar.robotics@gmail.com>
  * Contributors: Akash, Bence Magyar, Denis Štogl, Tim Clephas, Vatan Aksoy Tezer

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Sun, 27 Jun 2021 23:00:00 -0000

ros-jazzy-joint-trajectory-controller (0.3.1-1noble) noble; urgency=high

  * Reset external trajectory message upon activation (#185 <https://github.com/ros-controls/ros2_controllers/issues/185>)
    * Reset external trajectory message to prevent preserving the old goal on systems with hardware offsets
    * Fix has_trajectory_msg() function: two wrongs were making a right so functionally things were fine
  * Contributors: Nathan Brooks, Matt Reynolds

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Sat, 22 May 2021 23:00:00 -0000

ros-jazzy-joint-trajectory-controller (0.3.0-1noble) noble; urgency=high

  * joint_trajectory_controller publishes state in node namespace (#187 <https://github.com/ros-controls/ros2_controllers/issues/187>)
  * [JointTrajectoryController] Enable position, velocity and acceleration interfaces (#140 <https://github.com/ros-controls/ros2_controllers/issues/140>)
    * joint_trajectory_controller should not go into FINALIZED state when fails to configure, remain in UNCONFIGURED
  * Contributors: Bence Magyar, Denis Štogl

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Thu, 20 May 2021 23:00:00 -0000

ros-jazzy-joint-trajectory-controller (0.2.1-1noble) noble; urgency=high

  * Migrate from deprecated controller_interface::return_type::SUCCESS -> OK (#167 <https://github.com/ros-controls/ros2_controllers/issues/167>)
  * [JTC] Add link to TODOs to provide better trackability (#169 <https://github.com/ros-controls/ros2_controllers/issues/169>)
  * Fix JTC segfault (#164 <https://github.com/ros-controls/ros2_controllers/issues/164>)
    * Use a copy of the rt_active_goal to avoid segfault
    * Use RealtimeBuffer for thread-safety
  * Add basic user docs pages for each package (#156 <https://github.com/ros-controls/ros2_controllers/issues/156>)
  * Contributors: Bence Magyar, Matt Reynolds

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Sun, 02 May 2021 23:00:00 -0000

ros-jazzy-joint-trajectory-controller (0.2.0-1noble) noble; urgency=high

  * Use ros2 contol test assets (#138 <https://github.com/ros-controls/ros2_controllers/issues/138>)
    * Add description to test trajecotry_controller
    * Use ros2_control_test_assets package
    * Delete obsolete components plugin export
  * Contributors: Denis Štogl

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Sat, 06 Feb 2021 00:00:00 -0000

ros-jazzy-joint-trajectory-controller (0.1.2-1noble) noble; urgency=high



 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Thu, 07 Jan 2021 00:00:00 -0000

ros-jazzy-joint-trajectory-controller (0.1.1-1noble) noble; urgency=high



 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Wed, 06 Jan 2021 00:00:00 -0000

ros-jazzy-joint-trajectory-controller (0.1.0-1noble) noble; urgency=high

  * Remove lifecycle node controllers (#124 <https://github.com/ros-controls/ros2_controllers/issues/124>)
  * Use resource manager on joint trajectory controller (#112 <https://github.com/ros-controls/ros2_controllers/issues/112>)
  * Use new joint handles in all controllers (#90 <https://github.com/ros-controls/ros2_controllers/issues/90>)
  * More jtc tests (#75 <https://github.com/ros-controls/ros2_controllers/issues/75>)
  * remove unused variables (#86 <https://github.com/ros-controls/ros2_controllers/issues/86>)
  * Port over interpolation formulae, abort if goals tolerance violated (#62 <https://github.com/ros-controls/ros2_controllers/issues/62>)
  * Partial joints (#68 <https://github.com/ros-controls/ros2_controllers/issues/68>)
  * Use clamp function from rcppmath (#79 <https://github.com/ros-controls/ros2_controllers/issues/79>)
  * Reorder incoming out of order joint_names in trajectory messages (#53 <https://github.com/ros-controls/ros2_controllers/issues/53>)
  * Action server for JointTrajectoryController (#26 <https://github.com/ros-controls/ros2_controllers/issues/26>)
  * Add state_publish_rate to JointTrajectoryController (#25 <https://github.com/ros-controls/ros2_controllers/issues/25>)
  * Contributors: Alejandro Hernández Cordero, Anas Abou Allaban, Bence Magyar, Denis Štogl, Edwin Fan, Jordan Palacios, Karsten Knese, Victor Lopez

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Wed, 23 Dec 2020 00:00:00 -0000


